#include <dirent.h>
#include <stdio.h>
#include <stdlib.h> /* malloc */
#include <string.h> /* memset */
#include <errno.h>

int pokazErrno();

void listujPlikiLadnie(const char *nazwa_sciezki, unsigned ilosc_w_linii, unsigned rozmiar_bufora) { // (1)
  unsigned licznik = 0, i;
  char *bufor = (char*)malloc(sizeof(char)*rozmiar_bufora);
  
  struct dirent *plik;
  DIR *sciezka;
 
  if ( (sciezka = opendir(nazwa_sciezki)) ) {
    while( (plik = readdir(sciezka)) ) {
      memset(bufor, ' ', rozmiar_bufora);
      sprintf(bufor, "%s", plik->d_name);
      printf("%d)\t", ++licznik);
      
      for(i=0; i<rozmiar_bufora; ++i)	// (2)
	printf("%c", bufor[i]);
      printf("\t");
      if(! (licznik%ilosc_w_linii) )
	printf("\n");
    }
    pokazErrno();
    closedir(sciezka);
    pokazErrno();
    printf("\n");
  }
  else 
    pokazErrno();
  free(bufor);
}

int pokazErrno() { // (3)
  int errno_kopia = errno;
  if(errno) {
    printf("errno = %d:\t", errno); fflush(stdout); // (4)
    switch(errno) {
      case EACCES: 	perror("! (problem w OPENDIR) brak dostepu do czytanej sciezki"); break;
      case ELOOP: 	perror("! (problem w OPENDIR) zbyt wiele symbolicznych powiązań napotkanych w ścieżce"); break;
      case ENAMETOOLONG:perror("! (problem w OPENDIR) długość ścieżki przekracza PATH_MAX, lub długość nazw jej komponentów przekracza NAME_MAX"); break;
      case ENOENT: 	perror("! (problem w OPENDIR) ścieżka jest pustym stringiem, lub (problem w OPENDIR lub READDIR) składnik ścieżki nie jest nazwą istniejącej ścieżki\n"); break;
      case ENOTDIR: 	perror("! (problem w OPENDIR) komponent lub nazwa ścieżki nie jest ścieżką"); break; 
      case EMFILE: 	perror("! (problem w OPENDIR) jest otwarta liczba plików równa OPEN_MAX"); break;
      case ENFILE: 	perror("! (problem w OPENDIR) zbyt wiele plików jest obecnie otwartych przez system"); break;
      case EOVERFLOW:	perror("! (problem w READDIR) jedna z wartości w strukturze nie może być zwrócona poprawnie"); break;
      case EBADF: 	perror("! (problem w READDIR lub CLOSEDIR) argument funkcji readdir nie odnosi się do otwartego strumienia ścieżki"); break;
      case EINTR: 	perror("! (problem w CLOSEDIR) funkcja jest przerwana przez sygnał"); break;
    };
    errno = 0;
    printf("\n");
  }
  return errno_kopia;
}

main(int argc, char **argv) {
  if(argc>1)
    listujPlikiLadnie(argv[1], 4, 30);
  else
    listujPlikiLadnie(".", 4, 30);
}	//    gcc     listowanie2.c -o listowanie2 && ./listowanie2
