#include <dirent.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const char* typPliku(unsigned typ) {
    switch(typ) {
      case DT_UNKNOWN: 	return "Nieznany typ, nie wszystkie systemy rozróżniaja typy, czesto jest zwracana ta wartosc";
      case DT_REG: 	return "Regularny plik";
      case DT_DIR:	return "Katalog";
      case DT_FIFO:	return "Potok nazwany";
      case DT_SOCK:	return "Lokalne gniazdo";
      case DT_CHR:	return "Urządzenie znakowe 'A character device'";
      case DT_BLK:	return "Urzadzenie blokowe 'A block device'";
      case DT_LNK:	return "Dowiazanie symboliczne";
    };
}

int moj_filter(const struct dirent *plik) {
  printf("Filtruje nazwe: %s\t", plik->d_name);
  if(strstr(plik->d_name, ".c")==NULL) {
    printf("to nie plik .c ani .cc\n");
    return 0;
  }
  if(plik->d_type!=DT_REG) {
    printf("to nie jest zwykly plik\n");
    return 0;
  }
  printf(" <- jest OK\n");
  return 1;
}

int pokazChciane(const char * nazwa_sciezki, int (*filtr)(const struct dirent *), int (*porownywanie)(const struct dirent **, const struct dirent **)) {
    struct dirent **sciezka;
    int i, ilosc_elementow = scandir(".", &sciezka, filtr, porownywanie);
    
    printf("\nilosc elementow w katalogu = %d\n", ilosc_elementow);
    for(i=0; i<ilosc_elementow; ++i) {
        printf("%s\ttypu: '%s'\n", sciezka[i]->d_name, typPliku(sciezka[i]->d_type));
        free(sciezka[i]);    
    }
    free(sciezka);
    printf("\n");
    return ilosc_elementow;
}

main() {
  pokazChciane(".", moj_filter, alphasort);
}	//    gcc     listowanie5.c -o listowanie5 && ./listowanie5
