#include <iostream>
#include <fstream>
#include <dirent.h>
#include <cstdio>
#include <cerrno>
#include <string>
#include <cstring>
#include <set>
#include <iomanip>
#include <map>
#include <tuple>
#include <forward_list>
#include <boost/algorithm/string.hpp>
using namespace std;
using namespace boost;

int pokazErrno();

forward_list<string> plikNaWyrazy(const char* nazwa_pliku) {
  forward_list<string> wyrazy;
  
  const char * dstepy = " !	?.,;()[]{}'\":\n";	// (1)
  char znak[2] = {'\0', '\0'}; 				// 
  FILE * plik = fopen(nazwa_pliku, "r");
  string bufor_wyrazowy;

  while  ( ( znak[0] = fgetc( plik ) ) != EOF ) {
     if(strrchr ( dstepy, znak[0] )==NULL) 
	bufor_wyrazowy.append(znak);	// (2)
     else {
      trim(bufor_wyrazowy);		//
      to_lower(bufor_wyrazowy);		//

      if(!bufor_wyrazowy.empty())	//
	wyrazy.push_front(bufor_wyrazowy);
      bufor_wyrazowy.clear();
     }
  }
  
  fclose(plik);
  return wyrazy;
}

unsigned wyswietlWyrazy(forward_list<string>& wyrazy, ostream& strumien = cout, const char* odstep="\t") {	// (3)
  unsigned i=0;
  wyrazy.reverse();
  for (auto it = wyrazy.cbegin(); it != wyrazy.cend(); ++it ) {
    strumien << *it << odstep;
    ++i;
  }
  wyrazy.reverse();
  return i;
}

multimap<unsigned, string> szukajPodobienstw(forward_list<string>& wyrazy1, forward_list<string>& wyrazy2) {	// (4)
  multimap<unsigned, string> ciagi_podobne;
  string tmp;
  
  for(forward_list<string>::iterator it1 = wyrazy1.begin(), pomocniczy1; it1 != wyrazy1.end(); ++it1 ) {
    for(forward_list<string>::iterator it2 = wyrazy2.begin(), pomocniczy2; it2 != wyrazy2.end(); ++it2) {
      if((*it1)==(*it2)) {
	unsigned wyrazy_podobne = 0;
	for(pomocniczy1 = it1, pomocniczy2 = it2; pomocniczy1!=wyrazy1.cend(), pomocniczy2!=wyrazy2.cend(); ++pomocniczy1, ++pomocniczy2) {
	  if((*pomocniczy1)==(*pomocniczy2)) {
	    ++wyrazy_podobne;
	    tmp = (*pomocniczy2)+' '+tmp;
	  }
	  else {
	    ciagi_podobne.insert(make_pair(wyrazy_podobne, tmp));
	    tmp.clear();
	    break;
	  }
	}
	if(!tmp.empty()) {
	  ciagi_podobne.insert(make_pair(wyrazy_podobne, tmp));
	  tmp.clear();
	}
      }
    }
  }
  return ciagi_podobne;
}

unsigned long pokazPodobienstwa(multimap<unsigned, string> &wyrazy, unsigned ilo_wyrazowe_podobienstwa=3, ostream& strumien=cout) {	// (5)
  unsigned long punkty_podobienstwa = 0;
  for(auto it=wyrazy.cbegin();it!=wyrazy.cend();++it) 
    if(it->first >= ilo_wyrazowe_podobienstwa){
      strumien << it->first << " wyrazowe podobienstwo w wyrazach '" << it->second << "' punktowane: " << it->first*it->first << '\n';
      punkty_podobienstwa += it->first*it->first;
  }
  return punkty_podobienstwa;
}

set < string > listujPlikiPosortowane( const char * nazwa_sciezki, int (*filtr)(dirent *)) { // (6a)
    set < string > nazwy_plikow;
   
    struct dirent * plik;
    DIR * sciezka;
   
    if(( sciezka = opendir( nazwa_sciezki ) ) ) {
        pokazErrno();
       
        while(( plik = readdir( sciezka ) ) )
	  if(plik->d_type == DT_REG)
	    if( filtr(plik))
	      nazwy_plikow.insert( plik->d_name );
       
        pokazErrno();
       
        closedir( sciezka );
        pokazErrno();
    }
    pokazErrno();
   
    return nazwy_plikow;
}

set < string > listujPlikiPosortowane( const char * nazwa_sciezki) { // (6b)
    set < string > nazwy_plikow;
   
    struct dirent * plik;
    DIR * sciezka;
   
    if(( sciezka = opendir( nazwa_sciezki ) ) ) {
        pokazErrno();
       
        while(( plik = readdir( sciezka ) ) )
	  if(plik->d_type == DT_REG)
            nazwy_plikow.insert( plik->d_name );
       
        pokazErrno();
       
        closedir( sciezka );
        pokazErrno();
    }
    pokazErrno();
   
    return nazwy_plikow;
}


int pokazErrno() {
    int errno_kopia = errno;
    if( errno ) {
        printf( "errno = %d:\t", errno ); fflush( stdout );
        switch( errno ) {
        case EACCES: perror( "! (problem w OPENDIR) brak dostepu do czytanej sciezki" ); break;
        case ELOOP: perror( "! (problem w OPENDIR) zbyt wiele symbolicznych powiązań napotkanych w ścieżce" ); break;
        case ENAMETOOLONG: perror( "! (problem w OPENDIR) długość ścieżki przekracza PATH_MAX, lub długość nazw jej komponentów przekracza NAME_MAX" ); break;
        case ENOENT: perror( "! (problem w OPENDIR) ścieżka jest pustym stringiem, lub (problem w OPENDIR lub READDIR) składnik ścieżki nie jest nazwą istniejącej ścieżki\n" ); break;
        case ENOTDIR: perror( "! (problem w OPENDIR) komponent lub nazwa ścieżki nie jest ścieżką" ); break;
        case EMFILE: perror( "! (problem w OPENDIR) jest otwarta liczba plików równa OPEN_MAX" ); break;
        case ENFILE: perror( "! (problem w OPENDIR) zbyt wiele plików jest obecnie otwartych przez system" ); break;
        case EOVERFLOW: perror( "! (problem w READDIR) jedna z wartości w strukturze nie może być zwrócona poprawnie" ); break;
        case EBADF: perror( "! (problem w READDIR lub CLOSEDIR) argument funkcji readdir nie odnosi się do otwartego strumienia ścieżki" ); break;
        case EINTR: perror( "! (problem w CLOSEDIR) pojawia się wtedy gry funkcja jest przerwana przez sygnał" ); break;
        };
        errno = 0;
        printf( "\n" );
    }
    return errno_kopia;
}

void szukajPlagiatow(const char* plik_zrodlowy, const char *sciezka, int (*filtr)(dirent *)=NULL, ostream&strumien=cout, unsigned min_ilosc_punktow_za_wyrazy=3) {
  forward_list<string> zrodlo = plikNaWyrazy( plik_zrodlowy );
  set < string > lista_plikow;
  unsigned max_poobnych_wyrazow=0;
  
  forward_list<tuple<unsigned long, string, multimap<unsigned, string>>> suma_podobienstw;	// (7)

  if(filtr==NULL)	// (8)
    lista_plikow = listujPlikiPosortowane( sciezka );
  else
    lista_plikow = listujPlikiPosortowane( sciezka, filtr );

  for(auto &i : lista_plikow) {	// 8b
    forward_list<string> przeszukiwany = plikNaWyrazy( (string(sciezka)+"/"+i).c_str() );
    multimap<unsigned int, string> podobienstwa = szukajPodobienstw( zrodlo, przeszukiwany);
    max_poobnych_wyrazow = pokazPodobienstwa(podobienstwa);
    suma_podobienstw.push_front( make_tuple(max_poobnych_wyrazow, i, podobienstwa) );
  }

  if(max_poobnych_wyrazow>= pow(min_ilosc_punktow_za_wyrazy, 1./2.))	// (8c)
    strumien << "Dla pliku '" << plik_zrodlowy << "' jest zawierajacy " << (max_poobnych_wyrazow+1) << " punktow za wyrazy, lista:\n";
  else
    strumien << "Dla pliku '" << plik_zrodlowy << "' nie znaleziono zawierajacego co najmniej " << min_ilosc_punktow_za_wyrazy << " punktow za wyrazy\n";
  
  for(auto &i : suma_podobienstw) {	// (9)
    if(get<0>(i)>0) {
      strumien << "PUNKTOW ZA WYRAZY: " << get<0>(i) << " w pliku o nazwie '" << get<1>(i) << "' a oto lista:\n";
      for (multimap<unsigned, string>::iterator it=get<2>(i).begin(); it!=get<2>(i).end(); ++it)
	if((*it).first>=min_ilosc_punktow_za_wyrazy)
	strumien << "\t-) " << (*it).first << '\t' << (*it).second << '\n';
    }
  }
}

main() {
   forward_list<string> fl = plikNaWyrazy( "test.txt" );
   ofstream plik("output.txt");
   wyswietlWyrazy(fl, plik, "\n");
   plik << "_________________________\n";
   forward_list<string> fl2 = plikNaWyrazy( "test2.txt");
   wyswietlWyrazy(fl2, plik, "\n");
   multimap<unsigned, string> podobienstwa =  szukajPodobienstw( fl,  fl2);
   plik << "\nPunkty podobienstwa:\t" << pokazPodobienstwa(podobienstwa, 1, plik) << endl;
   
   szukajPlagiatow("test.txt", "teksty");	// (10)
}	//    g++-4.6 -std=c++0x plagiaty.cc -o plagiaty && ./plagiaty
